#include <hipfft.h>
#include <stdio.h>
#include <iostream>
#include <fftw3.h>

typedef fftwf_complex cplx;

void r2c_2d_fftw_ref(float* inputs, float* outputs)
{
    int batch = 1;
    int  rank    = 2;
    int  n[3]    = {4, 4, 0};
    int  howmany = 1;
    int* inembed = NULL;
    int  istride = 1;
    int  idist   = 0;;
    int* onembed = NULL;
    int  ostride = 1;
    int  odist   = 0;

    fftwf_plan plan;
    plan = fftwf_plan_many_dft_c2r(
        rank, n, howmany, (cplx*)inputs, inembed, istride, idist, outputs, onembed, ostride, odist, FFTW_ESTIMATE);
    fftwf_execute(plan);
    fftwf_destroy_plan(plan);
}

void test_hipfft2d(float* inputs, float* outputs)
{
    hipfftHandle plan;
    float* ing, *outg;
    hipMalloc(&ing, 24*4);
    hipMalloc(&outg, 32*4);
    hipMemcpy(ing, inputs, 24*4, hipMemcpyHostToDevice);
    hipfftResult res = hipfftPlan2d(&plan, 4, 4, HIPFFT_C2R);
    if(res!=0)
    {
        printf("hipfftPlan2d failure %d\n", res);
        return;
    }
    res=hipfftExecC2R(plan, (hipfftComplex*)ing, (hipfftReal*)outg);
    if(res!=0)
    {
        printf("hipfftExec failure %d\n", res);
        return;
    }
    hipMemcpy(outputs, outg, 16*4, hipMemcpyDeviceToHost);
}

int main()
{
    float inputs[24]={0,0,1,0,2,0,3,0,4,0,5,0,6,0,7,0,8,0,9,0,0,0,1,0};
    float outputs_ref[16];
    float outputs_hipfft[16];
    test_hipfft2d(inputs, outputs_hipfft);
    r2c_2d_fftw_ref(inputs, outputs_ref);
    for(int i=0; i<16; i++)
        std::cout << outputs_ref[i] << " " << outputs_hipfft[i] << "\n";
    return 0;
}
